<?php
#Проверки на файл с сайтами
if(!file_exists("sites.dat"))
	file_put_contents("sites.dat", "");

if(!is_readable("sites.dat")) 
	die("Файл sites.dat недоступен для чтения. Проверьте права доступа к файлу и папке со скриптом.");

if(!is_writable("sites.dat")) 
	die("Файл sites.dat недоступен для записи. Проверьте права доступа к файлу и папке со скриптом.");

#Сброс данных
if(isset($_GET['do'])) {
	if($_GET['do']=="flush") {
		file_put_contents("sites.dat", "");
	}
}

#Добавление сайтов
if(isset($_POST['sites'])){
	$data=explode("\n", trim(strtolower($_POST['sites'])));

	$sites = array();

	foreach ($data as $v) {
		$site=trim($v);

		list($domain,$pass) = explode(":", $site);
		if(strlen($pass)>0) {
			$cookie = auth_li($domain,$pass);
			$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv",$cookie);
		} else {
			$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv");
		}

		$data = trim($data);

		#Проверяем, доступна ли статистика
		if($data == '"статистика сайта";"обновлено {date} в {time}"') {
			echo "<br>Статистика сайта <strong>$site</strong> недоступна - его нет в LI, или нужен пароль, или пароль неправильный";
		} else {
			$sites[]=$site;
		}

	}


	$data = file_get_contents("sites.dat");
	$exist_sites = unserialize($data);

	#Объединяем с текущими и удаляем дубли
	if($exist_sites) {
		$merge = array_merge($exist_sites,$sites);
		$merge = array_unique($merge);
	} else $merge=$sites;

	file_put_contents("sites.dat", serialize($merge));
}
?>

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <title>Статистика LI</title>

    <style>
    	body {margin: 0 auto; font-family: Verdana; max-width: 900px;}
    	table.sites {border-collapse: collapse; border: 1px gray solid;}
    	table.sites td, table.sites th {padding: 5px;border: 1px gray solid;}
    </style>
  </head>

  <body>
<?php

$data = file_get_contents("sites.dat");
$sites = unserialize($data);

if(!$sites) {
	echo "<h2>Вы еще не добавили ни одного сайта</h2><p>Добавить (каждый сайт с новой строчки, если есть пароль - то site.ru:password):
	<form method=post>
		<textarea name='sites' rows=10 cols=50></textarea>
		<p><input type='submit' value='Добавить сайты'>
	</form>";
	die();
}

foreach ($sites as $site) {
	list($domain,$pass) = explode(":", $site);
	$csv[$domain]=get_stats($site);
}

for($i=0; $i<=30; $i++) {
	$stat[$i]['views']=0;
	$stat[$i]['visitors']=0; 
	$f=$sites[0];
	list($fd,$pass) = explode(":", $f);
	$stat[$i]['date']=$csv[$fd][$i]['date'];

	foreach ($sites as $site) {
		list($domain,$pass) = explode(":", $site);
		$stat[$i]['views']+=$csv[$domain][$i]['views'];
		$stat[$i]['visitors']+=$csv[$domain][$i]['visitors'];
	}
}

?>


<script type="text/javascript" src="https://www.google.com/jsapi"></script>
<script type="text/javascript">
 
// Load the Visualization API library and the piechart library.
google.load('visualization', '1.0', {'packages':['corechart']});
google.setOnLoadCallback(drawChart);
   // ... draw the chart...
 
function drawChart() {
 
    // Create the data table.
    var data = new google.visualization.DataTable();
        data.addColumn('date', 'Дата');
    data.addColumn('number', 'Посетителей');
    data.addColumn('number', 'Просмотров');
    data.addRows([
    <?php
    foreach($stat as $v) {
                $date=$v['date']*1000;
                echo "[new Date($date), {$v['visitors']}, {$v['views']}],\n";
    }
    ?>
]);
        var options = {'title':'Посещаемость, в день:',
        colors: ['blue','green'],
        'width':900,
        'height':300,
        'legend':{'position':'none'},
        'titleTextStyle':{'fontName':'Georgia','fontSize':20,'bold':false},
        chartArea: {width: '100%'},
        vAxis: {textPosition: 'in',minValue: 0},          
    };
 
    // Instantiate and draw our chart, passing in some options.
    var chart = new google.visualization.AreaChart(document.getElementById('chart_div'));
    chart.draw(data, options);
}
</script>
 

<div id="chart_div" style="width: 900px; height: 300px;"></div>


<table>
	<tr><td valign=top>
<h3>Статистика за вчера:</h3>

<table class="sites">
<tr><th>Сайт<th>Посетителей<th>Просмотров
<?php
$views=0; $visitors=0;
foreach ($sites as $site) {
	list($domain,$pass) = explode(":", $site);
	echo "<tr><td><a href=\"http://$domain/\">$domain</a><td>{$csv[$domain][30]['visitors']}<td>{$csv[$domain][30]['views']}";
	$views+=$csv[$domain][30]['views'];
	$visitors+=$csv[$domain][30]['visitors'];
}

echo "<tr><td><strong>Всего:</strong><td><strong>{$visitors}</strong><td><strong>{$views}</strong>";
?>
</table>

<p><a href="?do=flush" onclick="return confirm('Вы уверены, что хотите удалить все сайты?')" style="color: red;">Удалить все сайты</a>

<td width=50>&nbsp;

<td valign=top>
<p style="color: gray;">Каждый сайт с новой строчки, если есть пароль - то site.ru:password
<form method=post>
	<textarea name='sites' rows=10 cols=50></textarea>
	<p><input type='submit' value='Добавить сайты'>
</form>

</table>

<p align=center style="color: gray; font-size: 10pt;">&copy; <a href="http://spryt.ru/">Spryt</a>, 2015

</body>
</html>

<?php

#Получение статистики из csv
function get_stats($site) {

	list($domain,$pass) = explode(":", $site);
	if(strlen($pass)>0) {
		$cookie = auth_li($domain,$pass);
		$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv",$cookie);
	} else {
		$data=get_data("http://www.liveinternet.ru/stat/$domain/index.csv?graph=csv");
	}

	$strings = explode("\n", $data);
	unset($strings[0]);
	unset($strings[32]);

	$i=0;
	foreach ($strings as $key => $value) {
		
		list($date,$views,$visitors)=explode(";", $value);
		$date=str_replace("\"", "", $date)." ".date("Y");

		$date = str_replace(
			array("янв","фев","мар","апр","май","июн","июл","авг","сен","окт","ноя","дек"),
			array('January','February','March','April','May','June','July ','August','September','October','November','December'),
			$date);

		$csv[$i]['date']=strtotime($date);
		$csv[$i]['views']=$views;
		$csv[$i]['visitors']=$visitors;
		$i++;
	}

	return $csv;
}

#Авторизация и получение куки в LI
function auth_li($domain,$pass) {

	$c = curl_init("http://www.li.ru/stat/");
	curl_setopt($c, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($c, CURLOPT_POST, TRUE);
	curl_setopt($c, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0");
	curl_setopt($c, CURLOPT_POSTFIELDS, "url=$domain&password=$pass");
	curl_setopt($c, CURLOPT_HEADER, TRUE);
	curl_setopt($c, CURLOPT_FOLLOWLOCATION, true);
	$data = curl_exec($c);
	if($data === false) echo "\nCurl error: ".curl_error($c);
	
	$header=substr($data,0,curl_getinfo($c,CURLINFO_HEADER_SIZE));
	curl_close($c);

	preg_match_all("/Set-Cookie: (.*?)=(.*?);/i",$header,$res);
	$cookie='';
	foreach ($res[1] as $key => $value) $cookie.= $value.'='.$res[2][$key].'; ';

	if(strlen($cookie)==0) $cookie=FALSE;

	return $cookie;
}

function get_data($url,$cookie="") {

		$c = curl_init($url);
		curl_setopt($c, CURLOPT_RETURNTRANSFER, TRUE);
		curl_setopt($c, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:24.0) Gecko/20100101 Firefox/24.0");
		curl_setopt($c, CURLOPT_TIMEOUT, 30);
		curl_setopt($c, CURLOPT_COOKIE, $cookie);
		curl_setopt($c, CURLOPT_HEADER, FALSE);
		curl_setopt($c, CURLOPT_FOLLOWLOCATION, TRUE);
		$data = curl_exec($c);
		if($data === false) echo "\nCurl error: ".curl_error($c);
		curl_close($c);

		return $data;
	}

?>